package ssw.mj;

import ssw.mj.codegen.Code;
import ssw.mj.symtab.Tab;

/** 
 * The Parser for the MicroJava Compiler. 
 */
public class Parser {
	
	/** Maximum number of global variables per program */
	private static final int MAX_GLOBALS = 32767;
	
	/** Maximum number of fields per class */
	private static final int MAX_FIELDS = 32767;
	
	/** Maximum number of local variables per method */
	private static final int MAX_LOCALS = 127;

	/** Last recognized token; */
	private Token t;
  
	/** Lookahead token (not recognized).) */
	private Token la;
  
	/** Shortcut to kind attribute of lookahead token (la). */
	private int sym;
	
	
	/** According scanner */
	public Scanner scan;
		
	/** According code buffer */
	public Code code;
	
	/** According symbol table */
	public Tab tab;
	
	// TODO Exercise 3 - 6: implementation of parser

	public Parser(Scanner scanner) {
		tab = new Tab(this);
		la = new Token(Token.none, 1, 1);  // avoid crash when 1st symbol has scanner error
		scan = scanner;
		code = new Code(this);
	}
	
	/**
	 * Adds error message to the list of errors.
	 */
	public void error(String msgKey, Object... msgParams) {
		scan.errors.error(la.line, la.col, msgKey, msgParams);
		// panic mode
		throw new Error(Messages.getString("PANIC_MODE"));
	}

	/**
	 * Starts the analysis.
	 */
	public void parse() {
	}
}
