package ssw.mj.symtab;

import ssw.mj.Parser;

/**
 * MicroJava Symbol Table
 */
public class Tab {
	// Universe
	public static final Struct 
		noType = new Struct(Struct.None), 
		intType = new Struct(Struct.Int),
		charType = new Struct(Struct.Char),
		nullType = new Struct(Struct.Class);
		
	public Obj noObj, chrObj, ordObj, lenObj;

	public Parser parser;      // target for errors. 
	public Scope topScope;     // current scope
	private int level;         // nesting level of current scope
	
	// TODO Exercise 4: implementation of symbol table

	/**
	 * Set up "universe" (= predefined names).
	 */
	public Tab(Parser p) {
		parser = p;
	}
	
	
	/**
	 * String representation for JUnit test cases.
	 */
	public String dump() {
		StringBuilder sb = new StringBuilder();
		if (topScope != null) {
			topScope.dump(sb);
		}
		return sb.toString();
	}
}
